f.Add_CaseCNV_LengthStats <- function (Enr.df, CNV.df, GeneTable.ls)

	{
	GS.ls <- as.list (Enr.df$GS_ID)
		
	f.CaseCNV_Unit <- function (GS.ID)	
		{
		supp.keys   <- unlist (strsplit (GeneTable.ls[[GS.ID]]$CNV_case, split = ";")) 
		CNV_Supp.df <- CNV.df[match (supp.keys, CNV.df$Key), ] 

		f.CaseCNV_GeN <- function (genes.chv)
			{return (length (unlist (strsplit (genes.chv, split = ";"))))}
		
		mean_len.n  <- mean (log (CNV_Supp.df$Length))
		mean_geN.n  <- mean (unlist (lapply (CNV_Supp.df$Genes_eg, f.CaseCNV_GeN)))
		
		return (c (mean_len.n, mean_geN.n))
		}
	
	Add.df <- as.data.frame (t (as.data.frame (lapply (GS.ls, f.CaseCNV_Unit))))
	colnames (Add.df) <- c ("CaseCNV_MeanLen", "CaseCNV_MeanGeN")
	
	Enr.df <- cbind (Enr.df, Add.df)
	
	return (Enr.df)
	}